/// Copyright (c) 2010 Ruben Penalva. All rights reserved.
/// Redistribution and use in source and binary forms, with or without modification, 
/// are permitted provided that the following conditions are met:
///    1. Redistributions of source code must retain the above copyright notice, this 
///    list of conditions and the following disclaimer.
///    2. Redistributions in binary form must reproduce the above copyright notice,
///    this list of conditions and the following disclaimer in the documentation and/or
///    other materials provided with the distribution.
///    3. The name of the author may not be used to endorse or promote products derived
///    from this software without specific prior written permission.
///
/// THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES,
/// INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
/// A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, 
/// INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED 
/// TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
/// INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
/// LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF 
/// THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

#include "UnicodeString.h"

#include <windows.h>

#include "Exception.h"

#include <boost\scoped_array.hpp>

using namespace TestFrameWork;

std::string TestFrameWork::ConvertUTF16ToUTF8(const std::wstring& utf16String)
{
	/// Getting the required size
	int utf8StringSize = WideCharToMultiByte(CP_UTF8, 0, utf16String.c_str(), static_cast<int>(utf16String.size()), 0, 0, 0, 0);
	if (utf8StringSize == 0)
	{
		throw Exception();
	}

	/// Converting
	boost::scoped_array<char> utf8CharArray(new char[utf8StringSize + 1]);
	if (FAILED(WideCharToMultiByte(CP_UTF8, 0, utf16String.c_str(), static_cast<int>(utf16String.size()), utf8CharArray.get(), utf8StringSize, 0, 0)))
	{
		throw Exception();
	}
	
	utf8CharArray[utf8StringSize] = '\0';

	std::string utf8String(utf8CharArray.get());
	
	return utf8String;
}

std::wstring TestFrameWork::ConvertUTF8ToUTF16(const std::string& utf8String)
{
	/// Getting the required size
	int utf16StringSize = MultiByteToWideChar(CP_UTF8, 0, utf8String.c_str(), static_cast<int>(utf8String.size()), 0, 0);
	if (utf16StringSize == 0)
	{
		throw Exception();
	}

	/// Converting
	boost::scoped_array<wchar_t> utf16CharArray(new wchar_t[utf16StringSize + 1]);
	if (FAILED(MultiByteToWideChar(CP_UTF8, 0, utf8String.c_str(), static_cast<int>(utf8String.size()), utf16CharArray.get(), utf16StringSize)))
	{
		throw Exception();
	}

	utf16CharArray[utf16StringSize] = L'\0';

	std::wstring utf16String(utf16CharArray.get());
	
	return utf16String;
}
